#define floatX(x) float3(##x##, ##x##, ##x##)

float3 saturation(float3 rgb, float adjustment){
    const float3 W = float3(0.2125, 0.7154, 0.0721);
    float3 intensity = floatX(dot(rgb, W)); 
    return clamp(lerp(intensity, rgb, adjustment), floatX(0.0), floatX(1.0));
	}

float3 Tonemapping(float3 x){
    float3 A = floatX(1.80);
	float3 B = floatX(0.30);
    float3 C = floatX(0.35);
	float3 D = floatX(0.50);
    float3 E = floatX(0.20);
	float3 F = floatX(0.30);
    return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
	}

//float3 TMap(float3 x , float2 y , float z){ 
//    float3 exposureBias = lerp(lerp(lerp(float3(2.1, 2.1, 2.1),float3(2.5,2.2,1.),y.y),float3(2.,2.1,2.5),y.x),float3(1,1,1),z);
//	float3 curr = Tonemapping(exposureBias*x);
//    return pow(curr/Tonemapping(float3(15.2,15.2,15.2)),float3(1,1,1));
//}

float3 TMap(float3 x){
    x*=1.0;
    float A = 1.80;
	float B = 0.30;
    float C = 0.35;
	float D = 0.50;
    float E = 0.20;
	float F = 0.30;
    return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}